diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java
index 29df947b4..955bbd278 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java
@@ -54,9 +54,9 @@ public class WorldTypeFX {
         return this.hasSky;
     }
 
-    public float getCloudHeight() {
+    public float getCloudHeight(final @NotNull World world) {
         if (this.cloudHeight == null) {
-            return (this.worldType.getMaxY() + 1) - 20;
+            return (this.worldType.getMaxY(world) + 1) - 20;
         }
         return this.cloudHeight;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
index 33d113393..904c206ca 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
@@ -34,7 +34,7 @@ public class WorldTypeFXNether extends WorldTypeFX {
         float g = 0 / 255.0f;
         float b = 0 / 255.0f;
 
-        double temp = ((BiomeProviderNether) world.getBiomeProvider()).getTemperature(x, z);
+        double temp = world.getBiomeProvider().getTemperature(MathHelper.floor(x), MathHelper.floor(z));
 
         if (temp < 0.25) {
             r = 0.0f;
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
index 20f665cac..bfe1b2801 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -24,6 +24,7 @@ import net.minecraft.core.world.save.LevelStorageDummy;
 import net.minecraft.core.world.saveddata.SavedDataStorage;
 import net.minecraft.core.world.season.SeasonManager;
 import net.minecraft.core.world.season.Seasons;
+import net.minecraft.core.world.settings.WorldConfiguration;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.weather.IPrecipitation;
@@ -41,12 +42,10 @@ public class WorldClient extends World {
     public WorldClient(
         final @NotNull Minecraft mc,
         final @NotNull LevelStorage levelStorage,
-        final @Nullable String name,
-        final long seed,
-        final @NotNull Dimension dimension,
-        final @Nullable Biome startingBiome
+        final @Nullable WorldConfiguration worldConfiguration,
+        final @NotNull Dimension dimension
     ) {
-        super(levelStorage, name, seed, dimension, startingBiome);
+        super(levelStorage, worldConfiguration, dimension);
 
         this.mc = mc;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
index b3a826e02..6849c8bcc 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
@@ -19,6 +19,7 @@ import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.save.LevelStorageDummy;
+import net.minecraft.core.world.settings.WorldConfiguration;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -37,18 +38,14 @@ public class WorldClientMP extends WorldClient {
     public WorldClientMP(
         final @NotNull PacketHandlerClient packetHandler,
         final @NotNull Minecraft mc,
-        final long seed,
-        final int dimensionId,
-        final int worldTypeId
+        final @NotNull WorldConfiguration worldConfiguration,
+        final @NotNull Dimension dimension
     ) {
         super(
             mc,
             new LevelStorageDummy(),
-            "MpServer",
-            seed,
-            Dimension.getDimensionList().get(dimensionId),
-//            Registries.WORLD_TYPES.getItemByNumericId(worldTypeId)
-            null
+            worldConfiguration,
+            dimension
         );
 
         this.positionTypesList = new LinkedList<>();
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldEmpty.java b/game/client/src/main/java/net/minecraft/client/world/WorldEmpty.java
index 501578fda..0f4162b56 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldEmpty.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldEmpty.java
@@ -6,13 +6,14 @@ import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.save.LevelStorageDummy;
+import net.minecraft.core.world.settings.WorldConfiguration;
 import org.jetbrains.annotations.NotNull;
 
 public class WorldEmpty extends WorldClient {
     public static final @NotNull WorldEmpty INSTANCE = new WorldEmpty(Minecraft.getMinecraft());
 
     private WorldEmpty(final @NotNull Minecraft mc) {
-        super(mc, new LevelStorageDummy(), "Empty World", 0, Dimension.OVERWORLD, null);
+        super(mc, new LevelStorageDummy(), new WorldConfiguration(), Dimension.OVERWORLD);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleCollection.java b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleCollection.java
index 2f545381b..daa8264c9 100644
--- a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleCollection.java
+++ b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleCollection.java
@@ -2,7 +2,9 @@ package net.minecraft.core.data.gamerule;
 
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.world.settings.WorldConfiguration;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.HashMap;
 import java.util.Map;
@@ -11,6 +13,8 @@ public final class GameRuleCollection
 {
     private final Map<GameRule<?>, Object> gameRules = new HashMap<>();
 
+    private @Nullable WorldConfiguration.ChangeListener changeListener;
+
     public GameRuleCollection()
     {
         for (GameRule<?> gameRule : Registries.GAME_RULES)
@@ -19,6 +23,16 @@ public final class GameRuleCollection
         }
     }
 
+    public void setChangeListener(final @Nullable WorldConfiguration.ChangeListener changeListener) {
+        this.changeListener = changeListener;
+    }
+
+    private void notifyChange() {
+        if (this.changeListener != null) {
+            this.changeListener.onChanged();
+        }
+    }
+
     public <T> @NotNull T getValue(final @NotNull GameRule<T> gameRule)
     {
         Object o = gameRules.get(gameRule);
@@ -32,6 +46,7 @@ public final class GameRuleCollection
     public <T> void setValue(GameRule<T> gameRule, T value)
     {
         gameRules.put(gameRule, value);
+        this.notifyChange();
     }
 
     public void setValues(GameRuleCollection collection)
@@ -46,6 +61,7 @@ public final class GameRuleCollection
             }
             gameRules.put(gameRule, o);
         }
+        this.notifyChange();
     }
 
     public GameRuleCollection copy()
diff --git a/game/core/src/main/java/net/minecraft/core/world/Dimension.java b/game/core/src/main/java/net/minecraft/core/world/Dimension.java
index f4693a627..45c1f3258 100644
--- a/game/core/src/main/java/net/minecraft/core/world/Dimension.java
+++ b/game/core/src/main/java/net/minecraft/core/world/Dimension.java
@@ -8,11 +8,14 @@ import net.minecraft.core.block.BlockLogicPortal;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.save.DimensionData;
+import net.minecraft.core.world.settings.WorldConfiguration;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
+import java.util.Objects;
+
 public class Dimension
 {
 	public int id;
@@ -30,17 +33,15 @@ public class Dimension
 		this.portalBlock = portalBlock;
 		this.defaultWorldType = defaultWorldType;
 	}
-	
-	public DimensionData getDimensionData(World world)
-	{
-		if (world.dimension == this)
-		{
+
+	public @NotNull DimensionData getDimensionData(final @NotNull World world) {
+		if (world.dimension == this) {
 			return world.getDimensionData();
 		}
-		DimensionData dimensionData = world.getLevelStorage().getDimensionData(this);
-		if (dimensionData == null) dimensionData = new DimensionData(this.defaultWorldType);
-		
-		return dimensionData;
+
+		final @Nullable DimensionData dimensionData = world.getLevelStorage().getDimensionData(this);
+
+		return Objects.requireNonNull(dimensionData);
 	}
 	
 	public boolean canPortal(Dimension dim)
diff --git a/game/core/src/main/java/net/minecraft/core/world/LevelDimensionDataWrapper.java b/game/core/src/main/java/net/minecraft/core/world/LevelDimensionDataWrapper.java
new file mode 100644
index 000000000..b4bdb7b37
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/LevelDimensionDataWrapper.java
@@ -0,0 +1,65 @@
+package net.minecraft.core.world;
+
+import net.minecraft.core.data.gamerule.GameRuleCollection;
+import net.minecraft.core.world.config.spawning.SpawnerConfig;
+import net.minecraft.core.world.save.DimensionData;
+import net.minecraft.core.world.save.LevelData;
+import net.minecraft.core.world.save.WorldConfigurationReader;
+import net.minecraft.core.world.settings.SettingNodesValues;
+import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
+
+public class LevelDimensionDataWrapper implements WorldConfigurationReader {
+    private final @NotNull Dimension dimension;
+    private final @NotNull LevelData levelData;
+    private final @NotNull DimensionData dimensionData;
+
+    public LevelDimensionDataWrapper(final @NotNull Dimension dimension, final @NotNull LevelData levelData, final @NotNull DimensionData dimensionData) {
+        this.dimension = dimension;
+        this.levelData = levelData;
+        this.dimensionData = dimensionData;
+    }
+
+    @Override
+    public long getFinalNumericSeed() {
+        return this.levelData.getRandomSeed();
+    }
+
+    @Override
+    public @NotNull String getFinalWorldName() {
+        return this.levelData.getWorldName();
+    }
+
+    @Override
+    public @NotNull GameRuleCollection getGameRules() {
+        return this.levelData.getGameRules();
+    }
+
+    @Override
+    public @NotNull SpawnerConfig getSpawnerConfig() {
+        return this.levelData.getSpawnerConfig();
+    }
+
+    @Override
+    public boolean getCheatsEnabled() {
+        return this.levelData.getCheatsEnabled();
+    }
+
+    @Override
+    public @NotNull WorldType getWorldType(final @NotNull Dimension dimension) {
+        if (this.dimension.equals(dimension)) {
+            return this.dimensionData.getWorldType();
+        }
+
+        throw new RuntimeException("Tried to read un-wrapped dimension data!");
+    }
+
+    @Override
+    public @NotNull SettingNodesValues getDimensionSettings(final @NotNull Dimension dimension) {
+        if (this.dimension.equals(dimension)) {
+            return this.dimensionData.getDimensionSettings();
+        }
+
+        throw new RuntimeException("Tried to read un-wrapped dimension data!");
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index f511aaa17..63af916b6 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -36,13 +36,13 @@ import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
+import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkCache;
-import net.minecraft.core.world.chunk.ChunkCoordinate;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.ChunkSection;
-import net.minecraft.core.world.chunk.ChunkLoader;
 import net.minecraft.core.world.chunk.provider.ChunkProvider;
+import net.minecraft.core.world.config.season.SeasonConfig;
 import net.minecraft.core.world.config.spawning.SpawnerConfig;
 import net.minecraft.core.world.lighting.LightingEngine;
 import net.minecraft.core.world.lighting.LightingEngineLegacy;
@@ -51,7 +51,13 @@ import net.minecraft.core.world.pathfinder.PathFinder;
 import net.minecraft.core.world.pos.*;
 import net.minecraft.core.world.save.*;
 import net.minecraft.core.world.saveddata.SavedData;
+import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.SeasonManager;
+import net.minecraft.core.world.settings.SettingNodesValues;
+import net.minecraft.core.world.settings.ValueSettingNode;
+import net.minecraft.core.world.settings.WorldConfiguration;
+import net.minecraft.core.world.settings.WorldSettingNodes;
+import net.minecraft.core.world.settings.impl.SeasonSettingNode;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.weather.IPrecipitation;
 import net.minecraft.core.world.weather.Weather;
@@ -76,7 +82,6 @@ import java.util.TreeSet;
 import java.util.UUID;
 
 import static net.minecraft.core.Global.DAY_LENGTH_TICKS;
-import static net.minecraft.core.Global.accessor;
 import static net.minecraft.core.Global.isServer;
 
 public abstract class World implements MutableWorldSource {
@@ -140,6 +145,7 @@ public abstract class World implements MutableWorldSource {
     private final @NotNull LevelStorage levelStorage;
     private final @NotNull LevelData levelData;
     private final @NotNull DimensionData dimensionData;
+    private final @NotNull WorldConfigurationReader worldConfigurationReader;
     private final @NotNull BiomeProvider biomeProvider;
     private final @NotNull SeasonManager seasonManager;
     private final @NotNull WeatherManager weatherManager;
@@ -148,27 +154,28 @@ public abstract class World implements MutableWorldSource {
     private final @NotNull LightingEngine lightingEngine = new LightingEngineLegacy(this);
 
     private World(
-        final long seed,
-        final @Nullable String name,
         final @NotNull Dimension dimension,
         final @NotNull LevelStorage levelStorage,
+        final @Nullable WorldConfiguration worldConfiguration,
         final @Nullable LevelData levelData,
-        final @Nullable DimensionData dimensionData,
-        final @Nullable Biome startingBiome
+        final @Nullable DimensionData dimensionData
     ) {
-        if (name == null && levelData == null) {
-            throw new IllegalArgumentException("name and levelData cannot both be null!");
+        if (worldConfiguration == null && (levelData == null || dimensionData == null)) {
+            throw new IllegalArgumentException("worldConfiguration and levelData cannot both be null!");
         }
 
         this.levelStorage = levelStorage;
 
         // Set up level data
         this.isNewWorld = levelData == null;
-        this.levelData = Objects.requireNonNullElseGet(levelData, () -> new LevelData(seed, Objects.requireNonNull(name)));
+        this.levelData = Objects.requireNonNullElseGet(levelData, () -> new LevelData(Objects.requireNonNull(worldConfiguration)));
 
         // Set up dimension data
         this.dimension = dimension;
-        this.dimensionData = Objects.requireNonNullElseGet(dimensionData, () -> new DimensionData(this.dimension.defaultWorldType));
+        this.dimensionData = Objects.requireNonNullElseGet(dimensionData, () -> new DimensionData(this.dimension, Objects.requireNonNull(worldConfiguration)));
+
+        // Set up world configuration reader
+        this.worldConfigurationReader = new LevelDimensionDataWrapper(this.dimension, this.levelData, this.dimensionData);
 
         // Set up weather manager
         this.weatherManager = new WeatherManager(this,
@@ -181,11 +188,23 @@ public abstract class World implements MutableWorldSource {
         // Set up chunk provider
         this.chunkProvider = this.createChunkProvider(levelStorage);
 
+        final @NotNull SettingNodesValues dimensionSettings = this.dimensionData.getDimensionSettings();
+
         // Set up season manager
-        this.seasonManager = SeasonManager.fromConfig(this, this.getWorldType().getSeasonConfig());
+        if (dimensionSettings.getNodeValue(WorldSettingNodes.SINGLE_SEASON_ENABLED, this.worldConfigurationReader)) {
+            final @NotNull Season singleSeason = dimensionSettings.getNodeValue(WorldSettingNodes.SINGLE_SEASON_VALUE, this.worldConfigurationReader);
+            this.seasonManager = SeasonManager.fromConfig(this, SeasonConfig.builder().withSingleSeason(singleSeason).build());
+        } else {
+            this.seasonManager = SeasonManager.fromConfig(this, this.getWorldType().getSeasonConfig());
+        }
 
         // Set up biome provider
-        this.biomeProvider = this.getWorldType().createBiomeProvider(this);
+        if (dimensionSettings.getNodeValue(WorldSettingNodes.SINGLE_BIOME_ENABLED, this.worldConfigurationReader)) {
+            final @NotNull Biome biome = dimensionSettings.getNodeValue(WorldSettingNodes.SINGLE_BIOME_VALUE, this.worldConfigurationReader);
+            this.biomeProvider = new BiomeProviderSingleBiome(this, biome, biome.defaultTemperature, biome.defaultHumidity, biome.defaultVariety);
+        } else {
+            this.biomeProvider = this.getWorldType().createBiomeProvider(this);
+        }
 
         // Set up command manager
         this.commandManager.init();
@@ -193,7 +212,12 @@ public abstract class World implements MutableWorldSource {
         // Do world initialization
         if (this.isNewWorld && !this.isClientSide) {
             this.getWorldType().onWorldCreation(this);
-            this.getInitialSpawnLocation(startingBiome);
+
+            if (dimensionSettings.getNodeValue(WorldSettingNodes.STARTING_BIOME_ENABLED, this.worldConfigurationReader)) {
+                this.getInitialSpawnLocation(dimensionSettings.getNodeValue(WorldSettingNodes.STARTING_BIOME_VALUE, this.worldConfigurationReader));
+            } else {
+                this.getInitialSpawnLocation(null);
+            }
         }
         this.updateSkyBrightness();
     }
@@ -201,19 +225,15 @@ public abstract class World implements MutableWorldSource {
     // Usually called when a world is loaded or generated (Singleplayer & Server)
     public World(
         final @NotNull LevelStorage levelStorage,
-        final @Nullable String name,
-        final long seed,
-        final @NotNull Dimension dimension,
-        final @Nullable Biome startingBiome
+        final @Nullable WorldConfiguration worldConfiguration,
+        final @NotNull Dimension dimension
     ) {
         this(
-            seed,
-            name,
             dimension,
             levelStorage,
+            worldConfiguration,
             levelStorage.getLevelData(),
-            levelStorage.getDimensionData(dimension),
-            startingBiome
+            levelStorage.getDimensionData(dimension)
         );
     }
 
@@ -223,16 +243,22 @@ public abstract class World implements MutableWorldSource {
         final @NotNull Dimension dimension
     ) {
         this(
-            parent.getLevelData().getRandomSeed(),
-            parent.getLevelData().getWorldName(),
             dimension,
             parent.levelStorage,
+            null,
             new LevelData(parent.levelData),
-            parent.levelStorage.getDimensionData(dimension),
-            null
+            parent.levelStorage.getDimensionData(dimension)
         );
     }
 
+    public <T> @NotNull T getWorldSetting(final @NotNull ValueSettingNode<T> node) {
+        return this.dimensionData.getDimensionSettings().getNodeValue(node, this.worldConfigurationReader);
+    }
+
+    public <T> @NotNull T getWorldSettingOr(final @NotNull ValueSettingNode<T> node, final @NotNull T or) {
+        return this.dimensionData.getDimensionSettings().getNodeValueOr(node, or);
+    }
+
     public abstract void setLightningFlicker(final int flicker);
 
     public <T> T getGameRuleValue(final GameRule<T> gameRule) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
index a8455e7a2..8f3503e9d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
@@ -45,6 +45,9 @@ public class Biome
     protected @NotNull List<@NotNull SpawnListEntry> spawnableAmbientCreatureList = new ArrayList<>();
     private boolean hasSurfaceSnow = false;
     private boolean hasSurfaceIce = false;
+    public float defaultTemperature = 0.5f;
+    public float defaultHumidity = 0.5f;
+    public float defaultVariety = 0.5f;
     
     public Biome(String key)
     {
@@ -68,6 +71,13 @@ public class Biome
         this.spawnableAmbientCreatureList.add(new SpawnListEntry(MobButterfly.class, 65));
     }
 
+    public @NotNull Biome setDefaults(final float temperature, final float humidity, final float variety) {
+        this.defaultTemperature = temperature;
+        this.defaultHumidity = humidity;
+        this.defaultVariety = variety;
+        return this;
+    }
+
     public WorldFeature getRandomWorldGenForTrees(Random random)
     {
         if(random.nextInt(10) == 0)
